// =====================================================================
// 
// Copyright (C) 2000 - 2020 
//   Charles Brain <chbrain@dircon.co.uk>
//   Ilkka Toivanen <pile@aimo.kareltek.fi>
//   David Freese <w1hkj@bellsouth.net>
//
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
// File: ale.h
//
// =====================================================================

#ifndef ALE_H
#define ALE_H

#include <string>
#include <list>
#include <vector>

#include "threads.h"
#include "FTextView.h"

namespace ALE {

struct str_text { std::string text; FTextBase::TEXT_ATTR style; };

struct heard_fields {
	int preamble;
	std::string who;
	int LQA;
	std::string dtime;
	int compare (heard_fields a, heard_fields b) {
		if (a.who > b.who) return 1;
		if (a.who < b.who) return -1;
		if (a.LQA > b.LQA) return 1;
		if (a.LQA < b.LQA) return -1;
		if (a.dtime > b.dtime) return 1;
		if (a.dtime < b.dtime) return -1;
		return 0;
	}
};

extern void stop_ale_thread(void);
extern void start_ale_thread(void);

//extern void write_rxstr(std::string);
extern void write_rxstr(std::string rx_invo, int ber, int sinad);
extern void write_txstr(std::string);
extern void sort_rx();

extern void pause_scanning();
extern void continue_scanning();
extern void dwell_on_channel();

extern void sort_heard();
extern void parse_heard(int preamble, std::string addr, int ber, int sinad);
extern void update_heard();

extern void init_frequencies();

extern void add_scan_frequency();
extern void update_scn_frequencies();

extern void add_snd_frequency();
extern void update_snd_frequencies();

}

#endif
