// ----------------------------------------------------------------------------
// Copyright (C) 2020
//              David Freese, W1HKJ
//
// This file is part of fldigi
//
// fldigi is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
//
// fldigi is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
// ----------------------------------------------------------------------------

#ifndef ale_struct_H
#define ale_struct_H

#include <string>

struct ale_struct {

	int		X;
	int		Y;
	int		W;
	int		H;

	bool	rx_topline;
	bool	anycall;
	bool	allcall;
	bool	sounding;

	std::string	address;
	std::string	selcall_address4;
	std::string	selcall_address6;
	std::string	scn_frequencies;
	std::string	snd_frequencies;

/* std::string	channels: ffffff.f:scn:snd:mode(L-lsb, U-usb, A-am, F-fm):snd_interval 
 * each channel separated by a comma
*/
	std::string nets;
	std::string channels;

	int		aging;

	double	link_timeout;
	double	call_timeout;
	double	ack_timeout;
	double	listen;
	double	dwell_time;
	double	sounding_interval;
	double	call_retries;
	double	repeats;
	double	snd_hangup;
	int		scan_rate;
	int		decode_errors;
	double	tune;

//----------------------------------------------------------------------

	bool ale_config_last;

	void save_ale_config();
	void load_ale_config();
};

extern ale_struct ale_config;

#endif
